//style check
function applyChatTimestampStyles()
{
	if($ChatTimestampsStyle $= "TRUCE")
	{
		$ChatTimestampsStyle = "";
		
		$Pref::Chat::CustomChatTimestamps::TagsPrefix = "\c7[\c4";
		$Pref::Chat::CustomChatTimestamps::TagsSuffix = "\c7] ";
		$Pref::Chat::CustomChatTimestamps::AMPMEnabled = false;
		$Pref::Chat::CustomChatTimestamps::12HourEnabled = false;
		$Pref::Chat::CustomChatTimestamps::SecsEnabled = false;
		$Pref::Chat::CustomChatTimestamps::FullHour = true;
	}
	else if($ChatTimestampsStyle $= "STEAM")
	{
		$ChatTimestampsStyle = "";
		
		$Pref::Chat::CustomChatTimestamps::TagsPrefix = "\c3"; //steam timestamp is same color as name - blockland names are by default yellow
		$Pref::Chat::CustomChatTimestamps::TagsSuffix = "\c7 - ";
		$Pref::Chat::CustomChatTimestamps::AMPMEnabled = true;
		$Pref::Chat::CustomChatTimestamps::12HourEnabled = true;
		$Pref::Chat::CustomChatTimestamps::SecsEnabled = false;
		$Pref::Chat::CustomChatTimestamps::FullHour = false;
	}
	else //if($ChatTimestampsStyle $= "RAW")
	{
		$ChatTimestampsStyle = "";
		
		$Pref::Chat::CustomChatTimestamps::TagsPrefix = "\c7";
		$Pref::Chat::CustomChatTimestamps::TagsSuffix = " ";
		$Pref::Chat::CustomChatTimestamps::AMPMEnabled = false;
		$Pref::Chat::CustomChatTimestamps::12HourEnabled = false;
		$Pref::Chat::CustomChatTimestamps::SecsEnabled = true;
		$Pref::Chat::CustomChatTimestamps::FullHour = true;
	}
}

//default prefs
if($Pref::Chat::CustomChatTimestamps::Enabled $= "")
{
	$Pref::Chat::CustomChatTimestamps::Enabled = true;
	$ChatTimestampsStyle = "TRUCE";
	applyChatTimestampStyles();
}

//package
if(isPackage(CustomChatTimestampsPackage))
	deactivatePackage(CustomChatTimestampsPackage);
package CustomChatTimestampsPackage
{
    function newChatSO::addLine(%this, %line)
    {
		%timestamp = "";
		
		if($Pref::Chat::CustomChatTimestamps::Enabled)
		{
			%fullTime = getWord(getDateTime(), 1);
			%hour = getsubStr(%fullTime, 0, 2);
			%mins = getsubStr(%fullTime, 3, 2);
			%secs = getsubStr(%fullTime, 6, 2);
			%hour = mfloor(%hour);
			
			if($ChatTimestampsStyle !$= "")
				applyChatTimestampStyles();
			
			%extra = "";
			if(%hour < 12)
			{
				if($Pref::Chat::CustomChatTimestamps::AMPMEnabled)
					%extra = " AM";
				if($Pref::Chat::CustomChatTimestamps::12HourEnabled)
				{
					if(%hour <= 0)
						%hour += 12;
				}
			}
			else if(%hour >= 12)
			{
				if($Pref::Chat::CustomChatTimestamps::AMPMEnabled)
					%extra = " PM";
				if($Pref::Chat::CustomChatTimestamps::12HourEnabled)
				{
					if(%hour > 12)
						%hour -= 12;
				}
			}
			
			if($Pref::Chat::CustomChatTimestamps::FullHour && %hour < 10)
				%hour = "0" @ %hour;
			
			if($Pref::Chat::CustomChatTimestamps::SecsEnabled)
				%extra = ":" @ %secs @ %extra;
			
			%time = %hour @ ":" @ %mins @ %extra;
			
			%timestamp = $Pref::Chat::CustomChatTimestamps::TagsPrefix @ %time @ $Pref::Chat::CustomChatTimestamps::TagsSuffix @ "\c0";
		}
			
		Parent::addLine(%this, %timestamp @ %line);
    }
};
activatePackage(CustomChatTimestampsPackage);